//
// Stupid OpenGL 1.1 to 1.0 wrapper
// This code is sponsored by the lazyness of the PowerVR driver programmers
//
#ifndef _GL_WRAPPER_
#define _GL_WRAPPER_



/////////////////////
// FIXED CONVERTER //
/////////////////////

#define F2X(f)		( (int) ((f)*(65536)))
#define X2F(x)		((float) (x)/65536.0f)
#define X64BIT		__int64
#define XMUL(a,b)	( (int)( ((X64BIT)(a)*(b)) >> 16 ) )
#define XDIV(a,b)	( (int)( (((X64BIT)(a))<<16)/(b) ) )



//////////////
// #DEFINES //
//////////////

	// #define:
	#define MV_GL_MODELVIEW_MATRIX 0
	#define MV_GL_PROJECTION_MATRIX 1
	#ifdef MV_PDA
	   #define GL_MODELVIEW_MATRIX 0
	   #define GL_PROJECTION_MATRIX 1
   #endif	   
	//#define GL_MODELVIEW 0
	//#define GL_PROJECTION 1

					
	
//////////////
// MODIFIED //
//////////////

#ifdef MV_PDA
   void MV_API MV_glLightModelf(GLenum pname, GLfloat param);
	void MV_API MV_glColor4f(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);	
	void MV_API MV_glClearColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);	
	void MV_API MV_glLightf(GLenum light, GLenum pname, GLfloat param);	
	void MV_API MV_glLightfv(GLenum light, GLenum pname, const GLfloat *params);	
	void MV_API MV_glMaterialf(GLenum face, GLenum pname, GLfloat param);	
	void MV_API MV_glMaterialfv(GLenum face, GLenum pname, const GLfloat *params);	
   void MV_API MV_glAlphaFunc(GLenum func, GLclampf ref);	
	void MV_API MV_glClearDepthf(GLclampf depth);	
	void MV_API MV_glLightModelfv(GLenum pname, const GLfloat *params);	
#endif
	


////////////////
// CUSTOMIZED //
////////////////

#ifdef MV_PDA
   void MV_API MV_glGetFloatv(int param, float *values);
	void MV_API MV_glRotatef(GLfloat angle, GLfloat x, GLfloat y, GLfloat z);
	void MV_API MV_glTranslatef(GLfloat x, GLfloat y, GLfloat z);
	void MV_API MV_glLoadMatrixf(const GLfloat *m);	
	void MV_API MV_glMultMatrixf(const GLfloat *m);	
	void MV_API MV_glFrustum(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat zNear, GLfloat zFar);
	void MV_API MV_glOrtho(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat zNear, GLfloat zFar);	
	
	void MV_API MV_glPushMatrix();
	void MV_API MV_glPopMatrix();
   void MV_API MV_glLoadIdentity();
	void MV_API MV_glMatrixMode(GLenum mode);
#endif	


//////////////////
// LINK METHODS //
//////////////////

#ifdef MV_PDA
   #define glRotatef MV_glRotatef
   #define glTranslatef MV_glTranslatef
   #define glGetFloatv MV_glGetFloatv
   #define glOrtho MV_glOrtho
   #define glColor4f MV_glColor4f
   #define glMultMatrixf MV_glMultMatrixf
   #define glLoadMatrixf MV_glLoadMatrixf
   
   #define glLightModelf MV_glLightModelf
   #define glLightf MV_glLightf
   #define glLightfv MV_glLightfv
   #define glFrustum MV_glFrustum
   
   #define glLightModelfv MV_glLightModelfv
   #define glMaterialf MV_glMaterialf
   #define glMaterialfv MV_glMaterialfv
   
   #define glClearColor MV_glClearColor
   #define glAlphaFunc MV_glAlphaFunc
   #define glClearDepthf MV_glClearDepthf
   
   #define MVglLoadIdentity MV_glLoadIdentity
   #define MVglPopMatrix MV_glPopMatrix
   #define MVglPushMatrix MV_glPushMatrix
   #define MVglMatrixMode MV_glMatrixMode      
#else
   #define MVglLoadIdentity glLoadIdentity
   #define MVglPopMatrix glPopMatrix
   #define MVglPushMatrix glPushMatrix
   #define MVglMatrixMode glMatrixMode   
#endif   
   

/////////
#endif //
