//////////////////////////////////////////////
//                                          //
// project  : mVISIO v0.1a                  //
// file     : mvisio_button.H					  //
// author   : Achille Peternier             // 
// copyright: EPFL (C) 2005                 //
//												        //
//////////////////////////////////////////////



/////////////
// #DEFINE //
/////////////

	// Event type:
	typedef enum MV_BUTTON_EVENT
	{
			MV_BUTTON_MOUSEUP,
			MV_BUTTON_MOUSEDOWN,
			MV_BUTTON_SWITCH, 
			MV_BUTTON_MINMAXONMOUSEUP,						
	} MV_BUTTON_EVENT;
	
	#define MV_BUTTON_DEFAULT_COLOR   0.8f, 0.3f, 0.0f, 0.9f

	

////////////////////
// CLASS MVBUTTON //
////////////////////

/////////////////////////////////////////////////////////
typedef class MV_API MVBUTTON : public MVBOX // Box 2D //
/////////////////////////////////////////////////////////
{
/////////////
	public: //
/////////////

	// Const/Dest:
	MVBUTTON();
	~MVBUTTON();		
	
	// Settings:
	inline void setCaption(char *c)						{ if (c && MV_VALIDSTRING(c)) strcpy(caption, c); }
	inline void setFont(MVFONT *font)					{ this->font = font; }	
	inline void setEventType(MV_BUTTON_EVENT e)		{ eventType = e; }	
	inline char *getCaption()								{ return caption; }		
	inline MV_BUTTON_EVENT getEventType()				{ return eventType; }
	
	// Rendering:
	bool render(void *data = NULL);

////////////////
	protected: //
////////////////

	// Data:
	MVFONT *font;
	char caption[MV_MAXNUMBEROFCHARS];
	MV_BUTTON_EVENT eventType;
} MVBUTTON; // Button 2D
