//////////////////////////////////////////////
//                                          //
// project  : mVISIO v0.1a                  //
// file     : mvisio_camera.H					  //
// author   : Achille Peternier             // 
// copyright: EPFL (C) 2005                 //
//												        //
//////////////////////////////////////////////
#include "mvisio.h"



////////////////////
// CLASS MVCAMERA //
////////////////////

//////////////////////////////////////////////////////////
typedef class MV_API MVCAMERA : public MVNODE // Camera //
//////////////////////////////////////////////////////////
{   
/////////////
	public: //	
/////////////

	// Cons/dest:
	MVCAMERA();
	~MVCAMERA();		

	// Inline:
	inline void setPreRotation(float x, float y, float z) 
	{
	      #ifdef MV_CAVE
            MVSETTINGS::sendVector3(MV_CAMERA_SETPREROTATION, id, x, y, z);
         #endif
	      preRotation.set(x, y, z);
	}
	inline void setPreRotation(MVVECTOR3 p)        
	{ 
	      #ifdef MV_CAVE
            MVSETTINGS::sendVector3(MV_CAMERA_SETPREROTATION, id, p.x, p.y, p.z);
         #endif
	      preRotation = p; 
   }   
   inline void setUpDirection(const MVVECTOR3& up) { this->upDirection = up; }
   inline MVVECTOR3 getUpDirection()               { return upDirection; }
   inline MVMATRIX *getThisCameraMatrix()          { return &thisCameraMatrix; }
	static inline MVMATRIX *getCameraMatrix()       { return &cameraMatrix; }	
	static inline MVVECTOR3 getCameraPosition()     { return cameraPosition; }	
	inline MVVECTOR3 getPreRotation() const         { return preRotation; }
	static inline MVCAMERA *getThisPassCamera()     { return thisPassCamera; }
   
   // Movement:
   void moveDoom(float x, float y, float z);
   inline void moveDoom(MVVECTOR3 v)               { moveDoom(v.x, v.y, v.z); }

	// Rendering:
	bool render(void *data);		
	
//////////////
	private: //
//////////////	

	// Data:
	MVVECTOR3 preRotation, upDirection;
	MVMATRIX thisCameraMatrix;
	static MVMATRIX cameraMatrix;
	static MVVECTOR3 cameraPosition;	
	static MVCAMERA *thisPassCamera;
} MVCAMERA; // Camera

