//////////////////////////////////////////////
//                                          //
// project  : mVISIO v1.5a                  //
// file     : mvisio_client.H               //
// author   : Achille Peternier             // 
// copyright: EPFL (C) 2005                 //
//                                          //
//////////////////////////////////////////////


   
///////////
// TYPES //
///////////
typedef enum MV_CAVEID 
{      
      MV_FRONT,
      MV_BOTTOM,
      MV_LEFT,
      MV_RIGHT,
      MV_UP,
      MV_BACK,
      MV_TOP,
      MV_SCREEN0,
      MV_SCREEN1,
      MV_SCREEN2,
      MV_SCREEN3,
      MV_SCREEN4,
      MV_SCREEN5,
      MV_SCREEN6,
      MV_SCREEN7,
      MV_SCREEN8,
      MV_SCREEN9,
      MV_SCREENLAST,
} MV_CAVEID;



/////////////
// #DEFINE //
/////////////

   #define MV_MAXNUMBEROFCLIENTS MV_SCREENLAST
   
   
   
/////////////
// CLASSES //
/////////////

////////////////////////////////////////////////
typedef class MV_API MVCLIENT // Client class //
////////////////////////////////////////////////
{   
   friend class MVSETTINGS;
   friend class MVISIO;
   
/////////////
	public: //
/////////////

   // Const/dest:
   MVCLIENT();
   ~MVCLIENT();
   
   // Management:
   static bool cleanUp();
   static unsigned getNumberOfClients();
   
   // Settings:
   bool setIP(char *IP)          { if (IP && strlen(IP)<MS_IPSTRINGSIZE) {strcpy(this->IP, IP); return true; } return false; }
   char *getIP()                 { return IP; }
   void setID(MV_CAVEID ID)      { this->ID = ID; }
   MV_CAVEID getID()             { return ID; }   
   MSERVERCLIENT *getMCPtr()     { return clientPtr; }
   MVVECTOR3 getRotationAngle()  { return rotationAngle; }
   void resize(float FOV, int x, int y, int sx, int sy);
   
   // Update user position:
   static bool waitSync(int timeout);
   static bool putUser(float x, float y, float z);
	   
//////////////
   private: //
//////////////   

   // Chained list:
   static MVCLIENT *firstClient;
   MVCLIENT *prev, *next;
   
   // IP:
   char IP[MS_IPSTRINGSIZE];
   MV_CAVEID ID;
   MSERVERCLIENT *clientPtr;
   
   // Data:
   MVVECTOR3 rotationAngle;
} MVCLIENT;


