//////////////////////////////////////////////
//                                          //
// project  : mVISIO v1.7a                  //
// file     : mvisio_helper.H					  //
// author   : Achille Peternier             // 
// copyright: EPFL (C) 2007                 //
//												        //
//////////////////////////////////////////////
#include "mvisio.h"



/////////////
// #DEFINE //
/////////////

	// Default:
	#define MV_HELPER_DEFAULT_COLOR 1.0f, 0.8f, 0.2f, 0.5f



////////////////////
// CLASS MVHELPER //
////////////////////

//////////////////////////////////////////////////////////
typedef class MV_API MVHELPER : public MVNODE // Helper //
//////////////////////////////////////////////////////////
{   
/////////////
	public: //	
/////////////

	// Cons/dest:
	MVHELPER();
	~MVHELPER();		
	
	// Settings:
	inline void setRadius(float r)                           { radius = r; }
	inline float getRadius()                                 { return radius; }
	inline void setThickness(float t)                        { thickness = t; }
	inline float getThickness()                              { return thickness; }
	inline void setColor(MVCOLOR4 c)                         { color = c; }
	inline void setColor(float r, float g, float b, float a) { setColor(MVCOLOR4(r, g, b, a)); }
	inline MVCOLOR4 getColor()                               { return color; }	
	inline void setMin(MVVECTOR3 min)                        { bbMin = min; }
	inline void setMax(MVVECTOR3 max)                        { bbMax = max; }
	
	// Rendering:
	bool render(void *data);		
	
//////////////
	private: //
//////////////	

	// Data:	
	float radius, thickness;
	MVCOLOR4 color;
	MVVECTOR3 currentRotation, currentScale;
	MVVECTOR3 bbMin, bbMax;
} MVHELPER; // Helper
