//////////////////////////////////////////////
//                                          //
// project  : mVISIO v0.1a                  //
// file     : mvisio_hscrollbar.H			  //
// author   : Achille Peternier             // 
// copyright: EPFL (C) 2005                 //
//												        //
//////////////////////////////////////////////



/////////////
// #DEFINE //
/////////////

	// Default:
	#define MV_HSCROLLBAR_DEFAULT_BARSIZEX		64
	#define MV_HSCROLLBAR_DEFAULT_BARSIZEY		4
	#define MV_HSCROLLBAR_DEFAULT_CURSORSIZEX 16
	#define MV_HSCROLLBAR_DEFAULT_CURSORSIZEY 8
	#define MV_HSCROLLBAR_DEFAULT_CURSORCOLOR 0.8f, 0.3f, 0.0f, 0.9f 
	#define MV_HSCROLLBAR_DEFAULT_BARCOLOR    0.6f, 0.2f, 0.0f, 0.35f
	
	

////////////////////////
// CLASS MVHSCROLLBAR //
////////////////////////

///////////////////////////////////////////////////////////////////////////
typedef class MV_API MVHSCROLLBAR : public MVBOX // Horizontal scrollbar //
///////////////////////////////////////////////////////////////////////////
{
/////////////
	public: //
/////////////

	// Const/Dest:
	MVHSCROLLBAR();
	~MVHSCROLLBAR();		
	
	// Settings:	
	inline void setMinValue(float mv)								{ minValue = mv; }
	inline void setMaxValue(float mv)								{ maxValue = mv; }
	inline void setDisplayStatus(bool d)                     { MVBOX::setDisplayStatus(d); ((MVBUTTON *)getChild(0))->setDisplayStatus(d); }
	inline void setCursorSize(int s)
	{	      
	      float p = cursor->getPosition().x;
	      p += cursor->getSizeX()/2.0f;
	      p -= (float) s/2.0f;
	      cursor->setPosition(p, cursor->getPosition().y);
	      cursor->setSizes((int) s, cursor->getSizeY());	      
	}
	inline float getMinValue()                               { return minValue; }
	inline float getMaxValue()                               { return maxValue; }
	void setValue(float v);
	float getValue();
	inline MVBUTTON *getCursor()                             { return (MVBUTTON *)getChild(0); }
	
	// Rendering:
	bool render(void *data = NULL);

////////////////
	protected: //
////////////////	

	// Data:
	int scrollX, scrollY;
	float minValue, maxValue;	
	MVBUTTON *cursor;
} MVHSCROLLBAR; // Horizontal scrollbar
