//////////////////////////////////////////////
//                                          //
// project  : mVISIO v0.1a                  //
// file     : mvisio_settings.H             //
// author   : Achille Peternier             // 
// copyright: EPFL (C) 2005                 //
//                                          //
//////////////////////////////////////////////



/////////////
// #DEFINE //
/////////////

	// Default:
	#define MV_SETTINGS_DEFAULT_TITLE					MV_NAME
	#ifdef MV_PDA
	   #define MV_SETTINGS_DEFAULT_WINDOWX					240
	   #define MV_SETTINGS_DEFAULT_WINDOWY					320
	#else
	   #define MV_SETTINGS_DEFAULT_WINDOWX					640
	   #define MV_SETTINGS_DEFAULT_WINDOWY					480
	#endif
	#define MV_SETTINGS_DEFAULT_COLORDEPTH				16
	#define MV_SETTINGS_DEFAULT_ZETADEPTH				16
	#define MV_SETTINGS_DEFAULT_STENCILDEPTH			0
	#ifndef MV_PDA
		#define MV_SETTINGS_DEFAULT_FULLSCREEN				false	
	#else
		#define MV_SETTINGS_DEFAULT_FULLSCREEN				true	
	#endif
		
	#define MV_SETTINGS_DEFAULT_RESIZABLE           false
	#define MV_SETTINGS_DEFAULT_LANDSCAPE				false	
	#define MV_SETTINGS_DEFAULT_RENDERINGELEMENTS	0     // 0 = max available
	#define MV_SETTINGS_DEFAULT_MVEPATH					""
	#define MV_SETTINGS_DEFAULT_MVAPATH					""
	#define MV_SETTINGS_DEFAULT_MPGPATH             ""
	#define MV_SETTINGS_DEFAULT_TEXTUREPATH			""
	#define MV_SETTINGS_DEFAULT_SHADERPATH				""
	#define MV_SETTINGS_DEFAULT_FONTPATH				""
	#define MV_SETTINGS_DEFAULT_USESHADERS          false	
	#define MV_SETTINGS_DEFAULT_AUDIOCHANNELS			16
	#define MV_SETTINGS_DEFAULT_AUDIOBUFFERS			MV_SETTINGS_DEFAULT_AUDIOCHANNELS * 2
	#define MV_SETTINGS_DEFAULT_AUDIOELEMENTS			128	
   #define MV_SETTINGS_DEFAULT_CAVESPLASHSCREEN    false
   #ifdef MV_CAVE      
      #define MV_SETTINGS_DEFAULT_SERVICEPORT      55554
      #define MV_SETTINGS_DEFAULT_SERVERPORT       4444
      #define MV_SETTINGS_DEFAULT_SERVERIP         "192.168.0.5"            
      #define MV_SETTINGS_DEFAULT_COMMANDLINE      "C:\\CAVE\\mvisioClient.exe"
      #define MV_SETTINGS_DEFAULT_CAVESYNCDIR      "E:\\test"
      #define MV_SETTINGS_DEFAULT_CAVEPERFORMSYNC  true
   #endif
   #define MV_SETTINGS_DEFAULT_SHADOWMAPSIZE       1024
   #define MV_SETTINGS_DEFAULT_FBOSIZEX            1024
   #define MV_SETTINGS_DEFAULT_FBOSIZEY            768 
   #define MV_SETTINGS_DEFAULT_WATERSIZE           256  
   #define MV_SETTINGS_DEFAULT_HDRLUMINANCESIZE    256  
   #define MV_SETTINGS_DEFAULT_FORCEFBO			   false

   // CAVE commands:
   typedef enum MV_COMMAND
   {
         MV_ZERO = 0,
         
         // MVisio rendering:
         MV_LOADMVE,
         MV_MONO,             
         MV_STEREO,         
         MV_CLEAR,
         MV_BEGINRENDERING3D,
         MV_ENDRENDERING3D,
         MV_BEGINRENDERING2D,
         MV_ENDRENDERING2D,
         MV_SWAP,   
         MV_SETSKYBOX,
         MV_WIREFRAMEON,
         MV_WIREFRAMEOFF,
         MV_SHADOWINGON,
         MV_SHADOWINGOFF,
         MV_BLOOMINGON,
         MV_BLOOMINGOFF,
         MV_BLOOMINGINTENSITY,
         MV_DOFON,
         MV_DOFOFF,
         MV_DOFFOCUS,
         MV_DOFRANGE,
         MV_HDRON,
         MV_HDROFF,
         
         // Objects/nodes:
         MV_PASS,
         MV_CREATE,
         MV_DELETE,      
         MV_LINK,
         MV_UNLINK,         
         
         // Positioning:
         MV_SETPOSITION2D,
         MV_SETROTATION2D,    
         MV_SETPOSITION3D,
         MV_SETROTATION3D,  
		   MV_SETDIRECTION2D,
		   MV_SETDIRECTION3D,
         MV_MOVE2D,
         MV_ROTATE2D,         
         MV_MOVE3D,
         MV_ROTATE3D,     
         MV_SETTARGET2D,
         MV_SETTARGET3D,
         MV_SETTARGETNODE,
         MV_SETPOSITIONING,
         MV_SETMATRIX,
         
         // OpenGL params:
         MV_OPENGL_RESIZE,
         MV_OPENGL_FRUSTUM,
         MV_OPENGL_BACKGROUNDCOLOR,
         MV_OPENGL_GLOBALAMBIENTLIGHT, 
         MV_OPENGL_SETNEARPLANE,
         MV_OPENGL_SETFARPLANE, 
         
         // Light:
		   MV_LIGHT_SETLIGHTTYPE,
         MV_LIGHT_SETAMBIENT,
         MV_LIGHT_SETDIFFUSE,
         MV_LIGHT_SETSPECULAR, 
         MV_LIGHT_SETCUTOFF,
         MV_LIGHT_SETEXPONENT, 
         MV_LIGHT_CASTSHADOWS, 
         
         // Camera:
         MV_CAMERA_SETPREROTATION,     

         // Meshes:
         MV_MESH_SETDISPLAYSTATUS,
         
         // Textures:
         MV_TEXTURE_LOAD,
         MV_TEXTURE_CREATE,
		   MV_TEXTURE_SETFILTER,
         
         // Materials:
         MV_MATERIAL_SETAMBIENT,
         MV_MATERIAL_SETDIFFUSE,
         MV_MATERIAL_SETSPECULAR,
         MV_MATERIAL_SETEMISSION,
         MV_MATERIAL_SETSHININESS,
         MV_MATERIAL_SETTEXTURE,
         MV_MATERIAL_SETSHADER,
         
         // Shader params:
		   MV_SHADER_LOADSHADERS,		   
		   MV_SHADER_SETNAME,
		   MV_SHADER_BINDPARAMS,
         
         // Emitters:
         MV_EMITTER_LOAD,						
         MV_EMITTER_SETTEXTURE,					
		   MV_EMITTER_SETEMITTERTYPE,				
		   MV_EMITTER_SETMAXIMUMENERGY,			
		   MV_EMITTER_SETMAXIMUMVELOCITY,			
		   MV_EMITTER_SETMAXIMUMPARTICLESIZE,		
		   MV_EMITTER_SETMAXIMUMSPIN,				
		   MV_EMITTER_SETSPINNING,				
		   MV_EMITTER_SETGRAVITY,					
		   MV_EMITTER_SETCOLORSTART,				
		   MV_EMITTER_SETCOLOREND,				
		   MV_EMITTER_SETCENTER,					
		   MV_EMITTER_SETUPVECTOR,				
		   MV_EMITTER_SETSIZEX,					
		   MV_EMITTER_SETSIZEY,					
		   MV_EMITTER_SETRADIUS,					
		   MV_EMITTER_SETBLENDINGSRC,				
   		MV_EMITTER_SETBLENDINGDST,				
	   	MV_EMITTER_SETNUMBEROFPARTICLES,		         
         
         // Video:
		   MV_VIDEO_LOAD,			
		   MV_VIDEO_SETTEXTURE,	
		   MV_VIDEO_PLAY,			
		   MV_VIDEO_PLAYLOOP,
		   MV_VIDEO_STOP,		
		   MV_VIDEO_CMDREWIND,	
		   MV_VIDEO_UPDATE,
         
         // Terrain:       
         MV_TERRAIN_LOAD, 
		   MV_TERRAIN_SETWATERSPEED,
		   MV_TERRAIN_SETSKYSPEED,
		   
		   // Water:
		   MV_WATER_INIT,
		   MV_WATER_LOADTEXTURES,
		   MV_WATER_SETSPEED,
		   
		   // Skydome:
		   MV_SKYDOME_INIT,
		   MV_SKYDOME_LOADTEXTURE,
		   MV_SKYDOME_SETSPEED,
         
         // 2D and miscellaneous:
         MV_SETCURSOR,     
         MV_UPDATEVIDEO,
         MV_SETMONOCOLOR,
         MV_SETSTEREOCOLOR,
         MV_SKIPSHADOWS,
   } MV_COMMAND;



//////////////////////
// CLASS MVSETTINGS //
//////////////////////

//////////////////////////////////////////////////////
typedef class MV_API MVSETTINGS // Display settings //
//////////////////////////////////////////////////////
{  
	friend class MVISIO;
	friend class MVCLIENT;
	
/////////////
	public: //	
/////////////

	// Const/dest:
	MVSETTINGS();
	
	// Settings:
	inline void setTitle(char *n)						{ if (n && MV_VALIDSTRING(n)) strcpy(_title, n); }	
	inline void setWindowX(int x)						{ _windowX = x; }
	inline void setWindowY(int y)						{ _windowY = y; }
	inline void setColorDepth(int bits)				{ _colorDepth = bits; }
	inline void setZetaDepth(int bits)				{ _zetaDepth = bits; }
	inline void setStencilDepth(int bits)			{ _stencilDepth = bits; }		
	inline void setFullScreen(bool b)				{ _fullScreen = b; }	
	inline void setResizable(bool b)             { _resizable = b; }
	inline void setLandscape(bool b)					{ _landscape = b; }
	inline void setAudioChannels(int c)				{ _audioChannels = c; }
	inline void setAudioBuffers(int b)				{ _audioBuffers = b; }
	inline void setAudioElements(int e)				{ _audioElements = e; }	
	inline void setRenderingElements(int r)		{ _renderingElements = r; }
   inline void setCAVESplashScreen(bool cs)     { _CAVESplashScreen = cs; }
	inline void setMVEPath(char *p)					{ if (p && MV_VALIDSTRING(p)) strcpy(_mvePath, p); }
	inline void setMVAPath(char *p)					{ if (p && MV_VALIDSTRING(p)) strcpy(_mvaPath, p); }
	inline void setMPGPath(char *p)              { if (p && MV_VALIDSTRING(p)) strcpy(_mpgPath, p); }
	inline void setTexturePath(char *p)				{ if (p && MV_VALIDSTRING(p)) strcpy(_texturePath, p); }
	inline void setShaderPath(char *p)				{ if (p && MV_VALIDSTRING(p)) strcpy(_shaderPath, p); }
	inline void setFontPath(char *p)					{ if (p && MV_VALIDSTRING(p)) strcpy(_fontPath, p); }
	inline void setShaders(bool b)               { _useShaders = b; }
	inline void setShadowMapSize(int s)          { _shadowMapSize = s; }
	inline void setFBOSizeX(int s)               { _FBOSizeX = s; }
	inline void setFBOSizeY(int s)               { _FBOSizeY = s; }
	inline void setWaterSize(int s)              { _waterSize = s; }	
#ifdef MV_CAVE	
	inline void setCommandLine(char *c)          { if (c && MV_VALIDSTRING(c)) strcpy(_commandLine, c); }
	inline void setCAVESyncDirectory(char *c)    { if (c && MV_VALIDSTRING(c)) strcpy(_CAVESyncDir, c); }
   inline void setCAVESync(bool s)              { _CAVESync = s; }
#endif		
   inline void setForceFBO(bool f)              { _forceFBO = f; }
	inline char *getTitle()								{ return _title; }
	inline int getWindowX()	const						{ return _windowX; }
	inline int getWindowY()	const						{ return _windowY; }
	inline int getColorDepth() const					{ return _colorDepth; }
	inline int getZetaDepth() const					{ return _zetaDepth; }
	inline int getStencilDepth() const				{ return _stencilDepth; }		
	inline bool isFullScreen() const					{ return _fullScreen; }	
	inline bool isResizable() const              { return _resizable; }
	inline bool isLandscape() const              { return _landscape; }	
   inline bool isCAVESplashScreen() const       { return _CAVESplashScreen; }
	inline int getAudioChannels() const				{ return _audioChannels; }
	inline int getAudioBuffers() const				{ return _audioBuffers; }
	inline int getAudioElements() const				{ return _audioElements; }
	inline int getRenderingElements() const		{ return _renderingElements ; }
	inline bool getShaders() const               { return _useShaders; }
	inline int getShadowMapSize() const          { return _shadowMapSize; }
	inline int getFBOSizeX() const               { return _FBOSizeX; }
	inline int getFBOSizeY() const               { return _FBOSizeY; }
	inline int getWaterSize() const              { return _waterSize; }
#ifdef MV_CAVE
	inline char *getCommandLine()						{ return _commandLine; }
#endif	
   inline bool getForceFBO()                    { return _forceFBO; }
	inline char *getMVEPath()							{ return _mvePath; }
	inline char *getMVAPath()							{ return _mvaPath; }
	inline char *getMPGPath()                    { return _mpgPath; }
	inline char *getTexturePath()						{ return _texturePath; }
	inline char *getShaderPath()						{ return _shaderPath; }
	inline char *getFontPath()							{ return _fontPath; }
	static inline bool isActive() 					{ return active; }
	static inline char *getSDLTitle()				{ return title; }
	static inline int getSDLWindowX()				{ return windowX; }
	static inline int getSDLWindowY()				{ return windowY; }
	static inline int getSDLColorDepth()			{ return colorDepth; }
	static inline int getSDLZetaDepth()				{ return zetaDepth; }
	static inline int getSDLStencilDepth()			{ return stencilDepth; }
	static inline bool isSDLFullScreen()			{ return fullScreen; }
	static inline bool isSDLResizable()          { return resizable; }
	static inline bool isSDLLandscape()          { return landscape; }
	static inline bool getSDLShaders()           { return useShaders; }
	static inline int getSDLShadowMapSize()      { return shadowMapSize; }
	static inline int getSDLFBOSizeX()           { return FBOSizeX; }
	static inline int getSDLFBOSizeY()           { return FBOSizeY; }
	static inline int getSDLWaterSize()          { return waterSize; }
#ifdef MV_CAVE	
	static inline char *getSDLCommandLine()      { return commandLine; }
	static inline char *getSDLCAVESyncDirectory(){ return CAVESyncDir; }
   static inline bool getSDLCAVESync()          { return CAVESync; }
#endif	
   static inline bool getSDLForceFBO()          { return forceFBO; }
#ifdef WIN32
   static inline HWND getSDLWindow()            { return window; }
#endif   
	static inline int getEXAAudioChannels()		{ return audioChannels; }
	static inline int getEXAAudioBuffers()			{ return audioBuffers; }
	static inline int getEXAAudioElements()		{ return audioElements; }	
	static inline void forceShadersOff()         { useShaders = false; }
	static inline void forceShadersOn()          { useShaders = true; }	

   // CAVE specific:
#ifdef MV_CAVE   
   static void disableForwarding()              { forwarding = false; }
   static void enableForwarding()               { forwarding = true; }   
   static void bypassCAVEOn()                   { CAVEbypassed = true; }
   static void bypassCAVEOff()                  { CAVEbypassed = false; }
   static bool sendCommand(MV_COMMAND command, MVID id, MVCLIENT *target = NULL);
   static bool sendValue(MV_COMMAND command, MVID id, int value, MVCLIENT *target = NULL);   
   static bool sendVector2(MV_COMMAND command, MVID id, float x, float y, MVCLIENT *target = NULL);
   static bool sendVector3(MV_COMMAND command, MVID id, float x, float y, float z, MVCLIENT *target = NULL);
   static bool sendVector4(MV_COMMAND command, MVID id, float x, float y, float z, float w, MVCLIENT *target = NULL);
   static bool sendValueAndVector3(MV_COMMAND command, MVID id, int value, float x, float y, float z, MVCLIENT *target = NULL);
   static bool sendValueAndVector4(MV_COMMAND command, MVID id, int value, float x, float y, float z, float w, MVCLIENT *target = NULL);
   static inline bool sendVector2(MV_COMMAND command, MVID id, MVVECTOR2 v, MVCLIENT *target = NULL) { return sendVector2(command, id, v.x, v.y, target); }   
   static inline bool sendVector3(MV_COMMAND command, MVID id, MVVECTOR3 v, MVCLIENT *target = NULL) { return sendVector3(command, id, v.x, v.y, v.z, target); }
   static inline bool sendVector4(MV_COMMAND command, MVID id, MVVECTOR4 v, MVCLIENT *target = NULL) { return sendVector4(command, id, v.x, v.y, v.z, v.w, target); }   
   static inline bool sendValueAndVector3(MV_COMMAND command, MVID id, int value, MVVECTOR3 v, MVCLIENT *target = NULL) { return sendValueAndVector3(command, id, value, v.x, v.y, v.z, target); }   
   static inline bool sendValueAndVector4(MV_COMMAND command, MVID id, int value, MVVECTOR4 v, MVCLIENT *target = NULL) { return sendValueAndVector4(command, id, value, v.x, v.y, v.z, v.w, target); }   
   static bool sendFrustum(MV_COMMAND command, MVID id, float a, float b, float c, float d, float e, float f, MVCLIENT *target = NULL);
   static bool sendMatrix(MV_COMMAND command, MVID id, MVMATRIX matrix, MVCLIENT *target = NULL);
   static bool sendString(MV_COMMAND command, MVID id, char *string, MVCLIENT *target = NULL);       
   static bool sendStringAndString(MV_COMMAND command, MVID id, char *string1, char *string2, MVCLIENT *target = NULL);
   static bool sendStringStringAndValue(MV_COMMAND command, MVID id, char *string1, char *string2, int value, MVCLIENT *target = NULL);
   static bool sendStringAndVector2(MV_COMMAND command, MVID id, char *string, float x, float y, MVCLIENT *target = NULL);     
   static void setMono()
   {               
	      sendCommand(MV_MONO, NULL);      
   }                   
   static void setStereo()   
   {         
         sendCommand(MV_STEREO, NULL);      
   }   
   static void setMonoColor(MVCOLOR4 col)
   {
        MVSETTINGS::sendVector4(MV_SETMONOCOLOR, NULL, col.r, col.g, col.b, col.a);         
   }
   static void setMonoColor(float r, float g, float b, float a)
   {    
         setMonoColor(MVCOLOR4(r, g, b, a));
   }
   static void setStereoColor(MVCOLOR4 col)
   {
        MVSETTINGS::sendVector4(MV_SETSTEREOCOLOR, NULL, col.r, col.g, col.b, col.a);         
   }
   static void setStereoColor(float r, float g, float b, float a)
   {    
         setStereoColor(MVCOLOR4(r, g, b, a));
   }   
#endif
	
	// Config:	
	bool load(char *filename);	
	bool isOk();	
	
	// Windowing:
	static bool resize(int x, int y, int sizeX, int sizeY);		
	

//////////////
	private: //
//////////////	
	
	// Status:
	static bool active;
	
	// Display settings:
	static char title[MV_MAXNUMBEROFCHARS];
	static int windowX;
	static int windowY;
	static int colorDepth; 
	static int zetaDepth;
	static int stencilDepth;		
	static bool fullScreen;	
	static bool resizable;
	static bool landscape;
	static int audioChannels;
	static int audioBuffers;
	static int audioElements;
	static int renderingElements;
	static bool useShaders;   
	static int shadowMapSize;
	static int FBOSizeX;
	static int FBOSizeY;	
	static int waterSize;
	static bool forceFBO;
#ifdef WIN32	
   static HWND window;
#endif   
#ifdef MV_CAVE
   static char commandLine[MV_MAXNUMBEROFCHARS];
   static char CAVESyncDir[MV_MAXNUMBEROFCHARS];
   static bool CAVESync;
#endif   
#ifdef MV_PDA	
	static EGLDisplay glesDisplay;
	static EGLSurface glesSurface;
	static EGLContext glesContext;
#endif
	
	// Dynamic settings:
	char _title[MV_MAXNUMBEROFCHARS];
	int _windowX;
	int _windowY;
	int _colorDepth;
	int _zetaDepth;
	int _stencilDepth;	
	bool _fullScreen;
	bool _resizable;
	bool _landscape;
   bool _CAVESplashScreen;
	int _audioChannels;
	int _audioBuffers;	
	int _audioElements;
	int _renderingElements;
	bool _useShaders;
	int _shadowMapSize;
	int _FBOSizeX;
	int _FBOSizeY;	
	int _waterSize;
#ifdef MV_CAVE
	char _commandLine[MV_MAXNUMBEROFCHARS];
	char _CAVESyncDir[MV_MAXNUMBEROFCHARS];
   bool _CAVESync;
#endif
   bool _forceFBO;
	char _mvePath[MV_MAXNUMBEROFCHARS];
	char _mvaPath[MV_MAXNUMBEROFCHARS];
	char _mpgPath[MV_MAXNUMBEROFCHARS];
	char _texturePath[MV_MAXNUMBEROFCHARS];
	char _shaderPath[MV_MAXNUMBEROFCHARS];
	char _fontPath[MV_MAXNUMBEROFCHARS];	
	
	// Init/free SDL:
	bool init();	
	static bool free();
	
	// Init/free CAVE:
#ifdef MV_CAVE
	static bool wakeClient(char *IP, MV_CAVEID id);
   static bool initCAVE();
   static bool freeCAVE();   
   static bool netLoop();

   // CAVE server:
   static unsigned numberOfClients;
   static MSERVER server;
   static bool forwarding;
   static bool CAVEbypassed;   
#endif	
} MVSETTINGS; // Display's settings
