//////////////////////////////////////////////
//                                          //
// project  : mVISIO v1.6a                  //
// file     : mvisio_skydome.H				  //
// author   : Achille Peternier             //
//          : Sofien Bouaziz                // 
// copyright: EPFL (C) 2005-2008            //
//												        //
//////////////////////////////////////////////



/////////////
// #DEFINE //
/////////////

   // Default:
   #define MV_SKYDOME_DEFAULT_PHI     15.0f
   #define MV_SKYDOME_DEFAULT_THETA   15.0f



////////////////////////////
// CLASS MVSKYDOME_VERTEX //
////////////////////////////

///////////////////////////////////////////////////////////////
typedef class MV_API MVSKYDOME_VERTEX // Skydome coordinates //
///////////////////////////////////////////////////////////////
{
/////////////
   public: //
/////////////   
	
	// Settings:
	inline void setPosition(float x, float y, float z)	{ position.set(x, y, z); }
	inline void setTexCoord(float tU, float tV)	      { uv.set(tU, tV);	}


//////////////
   private: //
//////////////

   // Data:
	MVVECTOR3 position;
	MVUV uv;	
} MVSKYDOME_VERTEX; // Skydome coordinates



/////////////////////
// CLASS MVSKYDOME //
/////////////////////

////////////////////////////////////////////////////////////
typedef class MV_API MVSKYDOME : public MVNODE // Skydome //
////////////////////////////////////////////////////////////
{
/////////////
   public: //
/////////////

   // Const/dest:
	MVSKYDOME(); 
	~MVSKYDOME();	
	
	// Settings:
	void setSpeed(float _speed);
	void init(float _radius, float _phi = MV_SKYDOME_DEFAULT_PHI, float _theta = MV_SKYDOME_DEFAULT_THETA);
	bool loadTexture(char* _diffuse);
	
	// Rendering:
	bool render(void* _data = NULL);
		
		
//////////////
   private: //
//////////////
	
	// Methods:	
	void createDome();	
	
	// Data:
	float speed, timer, radius;	
	float dphi, dtheta;
	
	// OGL related:	
	unsigned int vertexBuffer;
	unsigned int indexBuffer;
	unsigned short nbIndices;
	
	// Material properties:
	MVTEXTURE* diffTexture;
	MVMATERIAL* material;
	MVSHADER* shader;
} MVSKYDOME; // Skydome