const char terrainComplexVS[] = ""
"varying vec3 normal, lightDir, eyeVec;"
"uniform float inv;"
"void main()"
"{"
"	gl_TexCoord[0] = gl_MultiTexCoord0;"
"	normal = gl_Normal;"
"	vec3 color = gl_Color;"
"	vec3 tangent = (gl_NormalMatrix * color);"
"	vec3 binormal = gl_NormalMatrix *(cross(color, normal));"
"	mat3 TBN_Matrix;"
"	TBN_Matrix[0] =  tangent;"
"	TBN_Matrix[1] =  binormal;" 
"	TBN_Matrix[2] =  gl_NormalMatrix * normal;"
"	vec3 vertex = vec3(gl_ModelViewMatrix * gl_Vertex);"
"	eyeVec = -vertex * TBN_Matrix;"
"	lightDir = vec3(gl_LightSource[0].position.xyz - vertex) * TBN_Matrix;"	
"	vec4 v = gl_Vertex;"
"	v.y *= inv;"
"	gl_ClipVertex = gl_ModelViewMatrix * v;"
"	gl_Position =  gl_ModelViewProjectionMatrix * v;"		
""
"  /*vec4 posWorld = gl_ModelViewMatrix * gl_Vertex;"  
"  gl_TexCoord[1] = gl_TextureMatrix[1] * posWorld;*/"
"}";  

const char terrainComplexPS[] = ""
"varying vec3 normal, lightDir, eyeVec;" 
"uniform sampler2D textureSampler0;"
"/*uniform sampler2DShadow textureSampler1;*/"
"uniform sampler2D textureSampler2;"
"uniform sampler2D textureSampler3;"
"uniform sampler2D textureSampler4;"
"uniform sampler2D textureSampler5;"
"uniform sampler2D textureSampler6;"
"uniform sampler2D textureSampler7;"
"uniform sampler2D textureSampler8;"
"uniform int repeat1;"
"uniform int repeat2;"
"uniform int repeat3;"
"uniform int repeat4;"
""
"/*const vec2 texmapscale = { vec2(1.0/2048.0, 1.0/2048.0) };"
"vec4 offset_lookup(sampler2DShadow map, vec4 loc, vec2 offset)"
"{"
"   return shadow2DProj(map, vec4(loc.xy+offset * texmapscale * loc.w, loc.z, loc.w));"
"}*/" 
""
"void main (void)"
"{"
"	vec2 texUV1 = gl_TexCoord[0].xy*repeat1;"
"	vec2 texUV2 = gl_TexCoord[0].xy*repeat2;"
"	vec2 texUV3 = gl_TexCoord[0].xy*repeat3;"
"	vec2 texUV4 = gl_TexCoord[0].xy*repeat4;"
"	float height1 = texture2D(textureSampler0, texUV1).a;"
"	float height2 = texture2D(textureSampler2, texUV2).a;"
"	float height3 = texture2D(textureSampler3, texUV3).a;"
"	float height4 = texture2D(textureSampler4, texUV4).a;"
"	float m1 = normal.z;"
"	float m2 = normal.x;"
"	float m3 = 1.0 - normal.y;"
"	float m1n = 1.0 - normal.z;" 
"	float m2n = 1.0 - normal.x;"
"	float m3n = normal.y;"
"	float parallax = height1*m1n + height2*m1;"
"	parallax = parallax*m2n + height3*m2;"
"	parallax = parallax*m3n + height4*m3;"
"	parallax = parallax * 0.034 - 0.004;"
"	vec3 eye = normalize(eyeVec);"
"	parallax = (eye.xy * parallax);"
"	texUV1 += parallax;"
"	texUV2 += parallax;"
"	texUV3 += parallax;"
"	texUV4 += parallax;"
"	vec4 normalGloss1 = texture2D(textureSampler5, texUV1).rgba;"
"	vec4 normalGloss2 = texture2D(textureSampler6, texUV2).rgba;"
"	vec4 normalGloss3 = texture2D(textureSampler7, texUV3).rgba;"
"	vec4 normalGloss4 = texture2D(textureSampler8, texUV4).rgba;"
"	vec3 diff1 = texture2D(textureSampler0, texUV1).rgb;"
"	vec3 diff2 = texture2D(textureSampler2, texUV2).rgb;"
"	vec3 diff3 = texture2D(textureSampler3, texUV3).rgb;"
"	vec3 diff4 = texture2D(textureSampler4, texUV4).rgb;"
"	vec3 diff = diff1*m1n + diff2*m1;"
"	diff = diff*m2n + diff3*m2;"
"	diff = diff*m3n + diff4*m3;"
"	vec4 normalGloss = normalGloss1*m1n + normalGloss2*m1;"
"	normalGloss = normalGloss*m2n + normalGloss3*m2;"
"	normalGloss = normalGloss*m3n + normalGloss4*m3;"
"	vec3 pixelColor = gl_LightSource[0].ambient.rgb;"	
"	vec3 N = normalize(normalGloss.rgb * 2.0 - 1.0);"
"	vec3 L = normalize(lightDir);"
"	float lambertTerm = dot(N,L);"
"	if(lambertTerm > 0.0)"
"	{"
"		pixelColor += gl_LightSource[0].diffuse.rgb * lambertTerm * diff;" 
"		vec3 half = normalize(L + eye);"
"		float specularTerm = max(dot(N, half), 0.0);"
"		float specular = pow(specularTerm, 60.0);"
"		pixelColor += gl_LightSource[0].specular.rgb * specular * normalGloss.a;" 	
"	}"
"/*"
"vec4 sum = (offset_lookup(textureSampler1, gl_TexCoord[1], vec2(-1.5, 0.5)) +"
"            offset_lookup(textureSampler1, gl_TexCoord[1], vec2(0.5, 0.5)) +"
"            offset_lookup(textureSampler1, gl_TexCoord[1], vec2(-1.5, -1.5)) +"
"            offset_lookup(textureSampler1, gl_TexCoord[1], vec2(0.5, -1.5))) * 0.25;"    
"*/"
"	gl_FragColor.rgb = pixelColor.rgb;"
"	gl_FragColor.a = 1.0f;" 			
"}";


const char terrainSimpleVS[] = ""
"varying vec3 normal, normalL, lightDir, eyeVec;"
"uniform float inv;"
"void main()"
"{"
"	gl_TexCoord[0] = gl_MultiTexCoord0;"
"	normal = gl_Normal;"
"	normalL = (gl_NormalMatrix * gl_Normal);"
"	vec3 vertex = vec3(gl_ModelViewMatrix * gl_Vertex);"
"	eyeVec = -vertex;"
"	lightDir = vec3(gl_LightSource[0].position.xyz - vertex);"	
"	vec4 v = gl_Vertex;"
"	v.y *= inv;"
"	gl_ClipVertex = gl_ModelViewMatrix * v;"
"	gl_Position =  gl_ModelViewProjectionMatrix * v;"		
"}";
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
const char terrainSimplePS[] = ""
"varying vec3 normal, normalL, lightDir, eyeVec;"
"uniform sampler2D textureSampler0;"
"uniform sampler2DShadow textureSampler1;"
"uniform sampler2D textureSampler2;"
"uniform sampler2D textureSampler3;"
"uniform sampler2D textureSampler4;"
"uniform int repeat1;"
"uniform int repeat2;"
"uniform int repeat3;"
"uniform int repeat4;"
"void main (void)"
"{"
"	vec2 texUV1 = gl_TexCoord[0].xy*repeat1;"
"	vec2 texUV2 = gl_TexCoord[0].xy*repeat2;"
"	vec2 texUV3 = gl_TexCoord[0].xy*repeat3;"
"	vec2 texUV4 = gl_TexCoord[0].xy*repeat4;"
"	vec3 diff1 = texture2D(textureSampler0, texUV1).rgb;"
"	vec3 diff2 = texture2D(textureSampler2, texUV2).rgb;"
"	vec3 diff3 = texture2D(textureSampler3, texUV3).rgb;"
"	vec3 diff4 = texture2D(textureSampler4, texUV4).rgb;"
"	vec3 diff = diff1*(1.0-normal.z) + diff2*normal.z;"
"	diff = diff*(1.0-normal.x) + diff3*normal.x;"
"	diff = diff*normal.y + diff4*(1.0-normal.y);"
"	vec3 pixelColor = gl_LightSource[0].ambient.rgb;"	
"	vec3 N = normalize(normalL);"
"	vec3 L = normalize(lightDir);"
"	float lambertTerm = max(dot(N,L), 0.0);"
"	pixelColor += gl_LightSource[0].diffuse.rgb * lambertTerm * diff;"
"	gl_FragColor.rgb = pixelColor.rgb;"
"	gl_FragColor.a = 1.0f;"			
"}";