//////////////////////////////////////////////
//                                          //
// project  : mVISIO v0.1a                  //
// file     : mvisio_vscrollbar.H			  //
// author   : Achille Peternier             // 
// copyright: EPFL (C) 2005                 //
//												        //
//////////////////////////////////////////////



/////////////
// #DEFINE //
/////////////

	// Default:
	#define MV_VSCROLLBAR_DEFAULT_BARSIZEX		4
	#define MV_VSCROLLBAR_DEFAULT_BARSIZEY		64
	#define MV_VSCROLLBAR_DEFAULT_CURSORSIZEX 8
	#define MV_VSCROLLBAR_DEFAULT_CURSORSIZEY 16
	#define MV_VSCROLLBAR_DEFAULT_CURSORCOLOR 0.8f, 0.3f, 0.0f, 0.9f 
	#define MV_VSCROLLBAR_DEFAULT_BARCOLOR    0.6f, 0.2f, 0.0f, 0.35f
	
	

////////////////////////
// CLASS MVVSCROLLBAR //
////////////////////////

/////////////////////////////////////////////////////////////////////////
typedef class MV_API MVVSCROLLBAR : public MVBOX // Vertical scrollbar //
/////////////////////////////////////////////////////////////////////////
{
/////////////
	public: //
/////////////

	// Const/Dest:
	MVVSCROLLBAR();
	~MVVSCROLLBAR();		
	
	// Settings:	
	inline void setMinValue(float mv)								{ minValue = mv; }
	inline void setMaxValue(float mv)								{ maxValue = mv; }
	inline void setDisplayStatus(bool d)                     { MVBOX::setDisplayStatus(d); ((MVBUTTON *)getChild(0))->setDisplayStatus(d); }
	inline void setCursorSize(int s)
	{	      
	      float p = cursor->getPosition().y;
	      p += cursor->getSizeY()/2.0f;
	      p -= (float) s/2.0f;
	      cursor->setPosition(cursor->getPosition().x, p);
	      cursor->setSizeY((int) s);	      
	}
	inline float getMinValue()                               { return minValue; }
	inline float getMaxValue()                               { return maxValue; }
	void setValue(float v);
	float getValue();
	inline MVBUTTON *getCursor()                             { return (MVBUTTON *)getChild(0); }
	
	// Rendering:
	bool render(void *data = NULL);

////////////////
	protected: //
////////////////	

	// Data:
	int scrollX, scrollY;
	float minValue, maxValue;	
	MVBUTTON *cursor;
} MVVSCROLLBAR; // Vertical scrollbar
