//////////////////////////////////////////////
//                                          //
// project  : mVISIO v1.6a                  //
// file     : mvisio_water.H  				  //
// author   : Achille Peternier             //
//          : Sofien Bouaziz                // 
// copyright: EPFL (C) 2005-2008            //
//												        //
//////////////////////////////////////////////



/////////////
// #DEFINE //
/////////////

   // Limits:   
   #define MV_WATER_DEFAULT_PLANESIZE   1024
   #define MV_WATER_DEFAULT_SPEED       0.005f
   
   
   
///////////////////
// CLASS MVWATER //
///////////////////

////////////////////////////////////////////////////////
typedef class MV_API MVWATER : public MVNODE // Water //
////////////////////////////////////////////////////////
{
/////////////
   public: //
/////////////

   // Const/dest:
   MVWATER(); 
	~MVWATER();
	void init(float _width, float _height);
	
   // Settings:
   bool loadTextures(char* _normal, char* _dudv, int _repeat);
	void setSpeed(float _speed);
	void getReflectionBuffer(unsigned int& _fb, unsigned int& _rb) { _fb = fb; _rb = rb; }
	void getRefractionBuffer(unsigned int& _fb, unsigned int& _rb) { _fb = fb2; _rb = rb2; }

   // Rendering:
	bool render(void* _data = NULL);
	
	
//////////////	
   private: //
//////////////

   // Methods:
   void createTexture();
	void createSurface();
	
	// Data:
	float speed;
	float timer;
	unsigned int fb, fb2, rb, rb2;	
	unsigned int displayList;
	MVMATERIAL* material;	
	MVTEXTURE* reflectionTexture;
	MVTEXTURE* refractionTexture;
	MVTEXTURE* normalGlossTexture;
	MVTEXTURE* dudvTexture;
	int repeat;
	float width, height;
} MVWATER;