///////////////////
// Water shader 
const char waterVS[] = ""
"varying vec3 lightDir, eyeVec;"
"varying vec4 position;"
"varying float camZ, time;"
"void main()"
"{"	
"	gl_TexCoord[0] = gl_MultiTexCoord0;"
"	time = gl_Color.x;"
"	vec3 normal = gl_NormalMatrix * vec3(0.0, 1.0, 0.0);"
"	vec3 tangent = gl_NormalMatrix *  vec3(1.0, 0.0, 0.0);"
"	vec3 binormal = gl_NormalMatrix * vec3(0.0, 0.0, 1.0);"
"	mat3 TBN_Matrix;"
"	TBN_Matrix[0] =  tangent;"
"	TBN_Matrix[1] =  binormal;" 
"	TBN_Matrix[2] =  normal;"
"	vec3 vertex = vec3(gl_ModelViewMatrix * gl_Vertex);"
"	eyeVec = -vertex * TBN_Matrix;"
"	lightDir = vec3(gl_LightSource[0].position.xyz - vertex) * TBN_Matrix;" 
"	mat4 MReflect = mat4(0.5, 0.0, 0.0, 0.0,"
"						 0.0, 0.5, 0.0, 0.0,"
"						 0.0, 0.0, 0.5, 0.0,"
"						 0.5, 0.5, 0.5, 1.0);"
"	position = ftransform();"
"	gl_Position = position;"
"	position = MReflect * position;"
"	vec4 camPos = gl_ModelViewMatrixInverse[3];"
""
"	camZ = camPos.y;"
"}";

const char waterPS[] = ""
"varying vec3 lightDir, eyeVec;"
"varying vec4 position;"
"varying float camZ, time;"
"uniform sampler2D textureSampler0;"
"uniform sampler2D textureSampler2;"
"uniform sampler2D textureSampler3;"
"uniform sampler2D textureSampler4;"
"uniform int repeat;"
""
"void main (void)"
"{"
"	vec2 coord = (gl_TexCoord[0].xy * repeat);"
"	vec2 texUV =  coord + time * vec2(2.0, 3.0);"
"	vec2 texUV2 = coord + time * vec2(3.0, 1.0);"
"	vec3 dudv = texture2D(textureSampler4, texUV2).rgb;"
"	dudv = (dudv * 2.0 - 1.0) * 0.019;"
"	vec3 normal = texture2D(textureSampler3, texUV + dudv.xy).rgb;"
"	position.xy = position.xy/position.w  + dudv.xy;"
"	vec3 refraction = texture2D(textureSampler2, position.xy).rgb;"
"	vec3 reflection = texture2D(textureSampler0, position.xy).rgb;"
"	vec3 pixelColor = gl_LightSource[0].ambient.rgb;"	
"	vec3 eye = normalize(eyeVec);"
"	vec3 N = normalize(normal * 2.0 - 1.0);"
"	vec3 L = normalize(lightDir);"
"	float fresnelWeight = max(dot(eye, sign(camZ)*N) , 0.0);"
"	vec3 diffuse = reflection*(1.0 - fresnelWeight) + refraction*fresnelWeight;"
"	float lambertTerm = dot(N,L);"
"	if (lambertTerm > 0.0)"
"	{"
"		pixelColor += gl_LightSource[0].diffuse.rgb * lambertTerm * diffuse; "
"		vec3 half = normalize(L + eye);"
"		float specularTerm = max(dot(N, half), 0.0);"
"		float specular = pow(specularTerm, 60.0);"
"		pixelColor += gl_LightSource[0].specular.rgb * specular;"
"	}"	
""
"	gl_FragColor.rgb = pixelColor.rgb;"
"	gl_FragColor.a = 1.0;" 			
"}";


///////////////////
// Water shader 
const char waterSVS[] = ""
"varying vec3 lightDir, eyeVec;"
"varying vec4 position;"
"varying float camZ, time;"
"void main()"
"{"	
"	gl_TexCoord[0] = gl_MultiTexCoord0;"
"	time = gl_Color.x;"
"	vec3 normal = gl_NormalMatrix * vec3(0.0, 1.0, 0.0);"
"	vec3 tangent = gl_NormalMatrix *  vec3(1.0, 0.0, 0.0);"
"	vec3 binormal = gl_NormalMatrix * vec3(0.0, 0.0, 1.0);"
"	mat3 TBN_Matrix;"
"	TBN_Matrix[0] =  tangent;"
"	TBN_Matrix[1] =  binormal;" 
"	TBN_Matrix[2] =  normal;"
"	vec3 vertex = vec3(gl_ModelViewMatrix * gl_Vertex);"
"	eyeVec = -vertex * TBN_Matrix;"
"	lightDir = vec3(gl_LightSource[0].position.xyz - vertex) * TBN_Matrix;" 
"	mat4 MReflect = mat4(0.5, 0.0, 0.0, 0.0,"
"						 0.0, 0.5, 0.0, 0.0,"
"						 0.0, 0.0, 0.5, 0.0,"
"						 0.5, 0.5, 0.5, 1.0);"
"	position = ftransform();"
"	gl_Position = position;"
"	position = MReflect * position;"
"	vec4 camPos = gl_ModelViewMatrixInverse[3];"
""
"  vec4 posWorld = gl_ModelViewMatrix * gl_Vertex;"  
"  gl_TexCoord[1] = gl_TextureMatrix[1] * posWorld;"
""
"	camZ = camPos.y;"
"}";

const char waterSPS[] = ""
"varying vec3 lightDir, eyeVec;"
"varying vec4 position;"
"varying float camZ, time;"
"uniform sampler2D textureSampler0;"
"uniform sampler2DShadow textureSampler1;"
"uniform sampler2D textureSampler2;"
"uniform sampler2D textureSampler3;"
"uniform sampler2D textureSampler4;"
"uniform float width;"
"uniform float height;"  
"uniform int repeat;"
""
"const vec2 texmapscale = vec2(1.0/width, 1.0/height);"
"vec4 offset_lookup(sampler2DShadow map, vec4 loc, vec2 offset)"
"{"
//"    return shadow2DProj(map, vec4(loc.xy+offset * texmapscale * loc.w, loc.z, loc.w));"
"    return shadow2DProj(map, vec4(loc.xy+offset * texmapscale * loc.ww, loc.z, loc.w));"
"}"
""
"void main (void)"
"{"
"	vec2 coord = (gl_TexCoord[0].xy * repeat);"
"	vec2 texUV =  coord + time * vec2(2.0, 3.0);"
"	vec2 texUV2 = coord + time * vec2(3.0, 1.0);"
"	vec3 dudv = texture2D(textureSampler4, texUV2).rgb;"
"	dudv = (dudv * 2.0 - 1.0) * 0.019;"
"	vec3 normal = texture2D(textureSampler3, texUV + dudv.xy).rgb;"
"	position.xy = position.xy/position.w  + dudv.xy;"
"	vec3 refraction = texture2D(textureSampler2, position.xy).rgb;"
"	vec3 reflection = texture2D(textureSampler0, position.xy).rgb;"
"	vec3 pixelColor = gl_LightSource[0].ambient.rgb;"	
"	vec3 eye = normalize(eyeVec);"
"	vec3 N = normalize(normal * 2.0 - 1.0);"
"	vec3 L = normalize(lightDir);"
"	float fresnelWeight = max(dot(eye, sign(camZ)*N) , 0.0);"
"	vec3 diffuse = reflection*(1.0 - fresnelWeight) + refraction*fresnelWeight;"
"	float lambertTerm = dot(N,L);"
"	if (lambertTerm > 0.0)"
"	{"
"		pixelColor += gl_LightSource[0].diffuse.rgb * lambertTerm * diffuse; "
"		vec3 half = normalize(L + eye);"
"		float specularTerm = max(dot(N, half), 0.0);"
"		float specular = pow(specularTerm, 60.0);"
"		pixelColor += gl_LightSource[0].specular.rgb * specular;"
"	}"	
""
"vec4 sum = (offset_lookup(textureSampler1, gl_TexCoord[1] + vec4(dudv.xy*30.0, 0.0, 0.0), vec2(-1.5, 0.5)) +"
"            offset_lookup(textureSampler1, gl_TexCoord[1] + vec4(dudv.xy*30.0, 0.0, 0.0), vec2(0.5, 0.5)) +"
"            offset_lookup(textureSampler1, gl_TexCoord[1] + vec4(dudv.xy*30.0, 0.0, 0.0), vec2(-1.5, -1.5)) +"
"            offset_lookup(textureSampler1, gl_TexCoord[1] + vec4(dudv.xy*30.0, 0.0, 0.0), vec2(0.5, -1.5))) * 0.25;"    
""
"	gl_FragColor.rgb = pixelColor.rgb * sum.rgb;"
"	gl_FragColor.a = 1.0;" 			
"}";