//////////////////////////////////////////////
//                                          //
// project  : mVISIO v0.1a                  //
// file     : mvisio_window.H					  //
// author   : Achille Peternier             // 
// copyright: EPFL (C) 2005                 //
//												        //
//////////////////////////////////////////////



/////////////
// #DEFINE //
/////////////

	// Limits:
	#define MV_MAXNUMBEROFCHARSPERWINDOW		4096-128	
	
	// Default:
	#define MV_WINDOW_DEFAULT_SIZEX				128
	#define MV_WINDOW_DEFAULT_SIZEY				128
	#define MV_WINDOW_DEFAULT_TITLEBARHEIGHT	19
	#define MV_WINDOW_DEFAULT_COLOR           0.0f, 0.0f, 0.6f, 0.9f
	#define MV_WINDOW_DEFAULT_TITLEBARCOLOR   0.8f, 0.3f, 0.0f, 0.9f
	#define MV_WINDOW_DEFAULT_SCROLLBARPOSX   8.0f
	#define MV_WINDOW_DEFAULT_SCROLLBARPOSY   16.0f

		

////////////////////
// CLASS MVWINDOW //
////////////////////

///////////////////////////////////////////////////////////////
typedef class MV_API MVWINDOW : public MVBUTTON // Window 2D //
///////////////////////////////////////////////////////////////
{
/////////////
	public: //
/////////////

	// Const/Dest:
	MVWINDOW();
	~MVWINDOW();		
	
	// Settings:
	inline void setCaption(char *c)								{ if (titlebar) titlebar->setCaption(c); }
	inline void setFont(MVFONT *font)							{ if (titlebar) titlebar->setFont(font); MVBUTTON::setFont(font); }
	inline void setSizes(int x, int y)							
	{ 
	      if (titlebar) titlebar->setSizes(x, titlebar->getSizeY()); 
	      if (scrollbar) 
	      { 
	            scrollbar->setSizeY((int) (y-MV_WINDOW_DEFAULT_SCROLLBARPOSY*2)); 
	            scrollbar->setPosition((float) x-MV_WINDOW_DEFAULT_SCROLLBARPOSX, MV_WINDOW_DEFAULT_SCROLLBARPOSY); 
	            scrollbar->setValue(0.0f);
         }
	      MVBUTTON::setSizes(x, y); 
	}
	inline void setScrollLine(int s)                      { scrollLine = s; }
	inline bool isMinimized()										{ return !minmax; }
   bool minmaximize();										
	inline MVBUTTON *getTitleBar()								{ return titlebar; }
	inline int getScrollLine() const                      { return scrollLine; }
	void enableScissor();
	void disableScissor();
	
	// Text editor:
	inline void clear()												{ strcpy(text, ""); textLine = 0; }
	bool write(char *t, ...);	
	bool format();
	
	// Rendering:
	bool updateScroll();
	bool render(void *data = NULL);

//////////////
	private: //
//////////////

	// Data:		
	bool minmax;
	char text[MV_MAXNUMBEROFCHARSPERWINDOW], displayText[MV_MAXNUMBEROFCHARSPERWINDOW];
	MVBUTTON *titlebar;
	MVVSCROLLBAR *scrollbar;	
	int scrollLine, oldScrollLine, maxLine, textLine;
} MVWINDOW; // Window 2D
